	; IntyBASIC compiler v0.1 Jan/28/2014
        ROMW 16
        ORG $5000
        
        ;
        ; ROM header
        ;
        BIDECLE _ZERO           ; MOB picture base
        BIDECLE _ZERO           ; Process table
        BIDECLE _MAIN           ; Program start
        BIDECLE _ZERO           ; Background base image
        BIDECLE _ONES           ; GRAM
        BIDECLE _TITLE          ; Cartridge title and date
        DECLE   $03C0           ; No ECS title, inits code after title,
                                ; ... no clicks
                                
_ZERO:  DECLE   $0000           ; Border control
        DECLE   $0000           ; 0 = color stack, 1 = f/b mode
        
_ONES:  DECLE   $0001, $0001    ; Initial color stack 0 and 1: Blue
        DECLE   $0001, $0001    ; Initial color stack 2 and 3: Blue
        DECLE   $0001           ; Initial border color: Blue

C_WHT:  EQU $0007

CLRSCR: MVII #$200,R4
        MVII #$F0,R1
FILLZERO:
        CLRR R0
MEMSET:
        MVO@ R0,R4
        DECR R1
        BNE MEMSET
        JR R5

        ;
        ; Title, avoid and jump directly into main program
        ;
_TITLE: PROC
        BYTE    114, 'IntyBASIC program', 0
;        BEGIN

;        RETURN                  ; Return to EXEC for title screen display
        ENDP

        ;
        ; Main program
        ;
_MAIN:
        DIS
        MVII    #STACK, R6

_MAIN0:
        MVII #$0fe,R1           ; 240 words of 8 bits plus 14 of sound
        MVII #$100,R4           ; 8-bit scratch RAM
        CALL FILLZERO
        MVII #$040,R1           ; 64 words of 16 bits
        MVII #$320,R4           ; 16-bit scratch RAM
        CALL FILLZERO

        CALL CLRSCR             ; Clean up screen

        MVII    #_int_vector,R0 ; Points to interrupt vector
        MVO     R0,     ISRVEC
        SWAP    R0
        MVO     R0,     ISRVEC+1
        MVII    #2,R0
        MVO R0,_first_time

        EIS
        MVII #7,R0
        MVO R0,_color
        MVII #$038,R0
        MVO R0,$01F8            ; Configures sound
	; 	REM
	;         REM Barzack 
	; 	REM Demo for IntyBASIC
	; 	REM by Oscar Toledo G. http://nanochess.org
	;         REM Jan/28/2014
	; 	REM
	; 
	; 	WAIT
	CALL _wait
	; 	DEFINE 0,4,drawings
	MVII #0,R0
	MVO R0,_gram_target
	MVII #4,R0
	MVO R0,_gram_total
	MVII #Q1,R4
	MVO R4,_gram_bitmap
	MVII #1,R0
	MVO R0,_load_gram
	; restart:
	; RESTART
Q2:	; 	WAIT
	CALL _wait
	;         room=0
	CLRR R0
	MVO R0,V1
	;         #score=0
	CLRR R0
	MVO R0,V2
	; load_room:
	; LOAD_ROOM
Q3:	;         if room=0 then restore room0:#monster=$081d
	MVI V1,R0
	CMPI #0,R0
	BNE T1
	MVII #Q4,R4
	MVO R4,_read
	MVII #2077,R0
	MVO R0,V3
T1:
	;         if room=1 then restore room1:#monster=$0805
	MVI V1,R0
	CMPI #1,R0
	BNE T3
	MVII #Q5,R4
	MVO R4,_read
	MVII #2053,R0
	MVO R0,V3
T3:
	; 
	;         ' Deactivate sprites
	;         SPRITE 0,0,0
	CLRR R0
	MVO R0,_mobs+0
	CLRR R0
	MVO R0,_mobs+8
	;         SPRITE 1,0,0
	CLRR R0
	MVO R0,_mobs+1
	CLRR R0
	MVO R0,_mobs+9
	;         SPRITE 2,0,0
	CLRR R0
	MVO R0,_mobs+2
	CLRR R0
	MVO R0,_mobs+10
	;         SPRITE 3,0,0
	CLRR R0
	MVO R0,_mobs+3
	CLRR R0
	MVO R0,_mobs+11
	;         SPRITE 4,0,0
	CLRR R0
	MVO R0,_mobs+4
	CLRR R0
	MVO R0,_mobs+12
	;         wait    ' Wait to reset collision bits
	CALL _wait
	; 
	;         ' Clean screen and draw room
	;         cls
	CALL CLRSCR
	MVII #$200,R0
	MVO R0,_screen
	;         print at 0,(#score/100%10+16)*8+6
	MVII #512,R0
	MVO R0,_screen
	MVI V2,R0
	MVII #-1,R4
T5:
	INCR R4
	SUBI #100,R0
	BC T5
	MOVR R4,R0
T6:
	SUBI #10,R0
	BC T6
	ADDI #10,R0
	ADDI #16,R0
	SLL R0,2
	SLL R0,1
	ADDI #6,R0
	MVI _screen,R4
	MVO@ R0,R4
	MVO R4,_screen
	;         print at 20,(#score/10%10+16)*8+6
	MVII #532,R0
	MVO R0,_screen
	MVI V2,R0
	MVII #-1,R4
T7:
	INCR R4
	SUBI #10,R0
	BC T7
	MOVR R4,R0
T8:
	SUBI #10,R0
	BC T8
	ADDI #10,R0
	ADDI #16,R0
	SLL R0,2
	SLL R0,1
	ADDI #6,R0
	MVI _screen,R4
	MVO@ R0,R4
	MVO R4,_screen
	;         print at 40,(#score%10+16)*8+6
	MVII #552,R0
	MVO R0,_screen
	MVI V2,R0
T9:
	SUBI #10,R0
	BC T9
	ADDI #10,R0
	ADDI #16,R0
	SLL R0,2
	SLL R0,1
	ADDI #6,R0
	MVI _screen,R4
	MVO@ R0,R4
	MVO R4,_screen
	;         print color 1
	MVII #1,R0
	MVO R0,_color
	;         for y=0 to 11
	CLRR R0
	MVO R0,V4
T10:
	;         read #line
	MVI _read,R4
	MVI@ R4,R0
	MVO R4,_read
	MVO R0,V5
	;         for x=0 to 15
	CLRR R0
	MVO R0,V6
T11:
	;         if #line and $8000 then print at y*20+x+2,"\95"
	MVI V5,R0
	ANDI #32768,R0
	TSTR R0
	BEQ T12
	MVI V4,R0
	MVII #19,R4
	MOVR R0,R5
T13:
	ADDR R5,R0
	DECR R4
	BNE T13
	ADD V6,R0
	ADDI #2,R0
	ADDI #512,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #760,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
T12:
	;         #line = #line * 2
	MVI V5,R0
	SLL R0,1
	MVO R0,V5
	;         next 
	MVII #15,R0
	CMP V6,R0
	BLE T14
	MVI V6,R0
	INCR R0
	MVO R0,V6
	B T11
T14:
	;         next
	MVII #11,R0
	CMP V4,R0
	BLE T15
	MVI V4,R0
	INCR R0
	MVO R0,V4
	B T10
T15:
	;         ' Random barzacks
	;         y=1:gosub barzack:y2=y*8+8:x2=result
	MVII #1,R0
	MVO R0,V4
	CALL Q6
	MVI V4,R0
	SLL R0,2
	SLL R0,1
	ADDI #8,R0
	MVO R0,V7
	MVI V9,R0
	MVO R0,V8
	;         y=4:gosub barzack:y3=y*8+8:x3=result
	MVII #4,R0
	MVO R0,V4
	CALL Q6
	MVI V4,R0
	SLL R0,2
	SLL R0,1
	ADDI #8,R0
	MVO R0,V10
	MVI V9,R0
	MVO R0,V11
	;         y=7:gosub barzack:y4=y*8+8:x4=result
	MVII #7,R0
	MVO R0,V4
	CALL Q6
	MVI V4,R0
	SLL R0,2
	SLL R0,1
	ADDI #8,R0
	MVO R0,V12
	MVI V9,R0
	MVO R0,V13
	;         y=10:gosub barzack:y5=y*8+8:x5=result
	MVII #10,R0
	MVO R0,V4
	CALL Q6
	MVI V4,R0
	SLL R0,2
	SLL R0,1
	ADDI #8,R0
	MVO R0,V14
	MVI V9,R0
	MVO R0,V15
	;         ' Player start
	;         x1=32
	MVII #32,R0
	MVO R0,V16
	;         y1=28
	MVII #28,R0
	MVO R0,V17
	; 
	;         room = room+1
	MVI V1,R0
	INCR R0
	MVO R0,V1
	;         if room=2 then room=0
	MVI V1,R0
	CMPI #2,R0
	BNE T16
	CLRR R0
	MVO R0,V1
T16:
	; 
	; loop:
	; LOOP
Q7:	;         WAIT
	CALL _wait
	;         ' Update MOBs
	;         SPRITE 0,X1+$300,Y1+$100,$0812 ' Our hero
	MVI V16,R0
	ADDI #768,R0
	MVO R0,_mobs+0
	MVI V17,R0
	ADDI #256,R0
	MVO R0,_mobs+8
	MVII #2066,R0
	MVO R0,_mobs+16
	;         SPRITE 1,X2+$300,Y2+$100,#monster        ' Mutant barzack
	MVI V8,R0
	ADDI #768,R0
	MVO R0,_mobs+1
	MVI V7,R0
	ADDI #256,R0
	MVO R0,_mobs+9
	MVI V3,R0
	MVO R0,_mobs+17
	;         SPRITE 2,X3+$300,Y3+$100,#monster' Mutant barzack
	MVI V11,R0
	ADDI #768,R0
	MVO R0,_mobs+2
	MVI V10,R0
	ADDI #256,R0
	MVO R0,_mobs+10
	MVI V3,R0
	MVO R0,_mobs+18
	;         SPRITE 3,X4+$300,Y4+$100,#monster' Mutant barzack
	MVI V13,R0
	ADDI #768,R0
	MVO R0,_mobs+3
	MVI V12,R0
	ADDI #256,R0
	MVO R0,_mobs+11
	MVI V3,R0
	MVO R0,_mobs+19
	;         SPRITE 4,X5+$300,Y5+$100,#monster' Mutant barzack
	MVI V15,R0
	ADDI #768,R0
	MVO R0,_mobs+4
	MVI V14,R0
	ADDI #256,R0
	MVO R0,_mobs+12
	MVI V3,R0
	MVO R0,_mobs+20
	;         ' Check for collision
	;         IF COL0 AND $011e THEN GOTO touched
	MVI _col0,R0
	ANDI #286,R0
	TSTR R0
	BEQ T18
	B Q8
T18:
	;         IF COL1 AND $0100 THEN Y2=0:BLINK=1
	MVI _col1,R0
	ANDI #256,R0
	TSTR R0
	BEQ T19
	CLRR R0
	MVO R0,V7
	MVII #1,R0
	MVO R0,V18
T19:
	;         IF COL2 AND $0100 THEN Y3=0:BLINK=1
	MVI _col2,R0
	ANDI #256,R0
	TSTR R0
	BEQ T20
	CLRR R0
	MVO R0,V10
	MVII #1,R0
	MVO R0,V18
T20:
	;         IF COL3 AND $0100 THEN Y4=0:BLINK=1
	MVI _col3,R0
	ANDI #256,R0
	TSTR R0
	BEQ T21
	CLRR R0
	MVO R0,V12
	MVII #1,R0
	MVO R0,V18
T21:
	;         IF COL4 AND $0100 THEN Y5=0:BLINK=1
	MVI _col4,R0
	ANDI #256,R0
	TSTR R0
	BEQ T22
	CLRR R0
	MVO R0,V14
	MVII #1,R0
	MVO R0,V18
T22:
	;         ' Check for movement
	; 	IF CONT1.UP THEN IF Y1>0 THEN Y1=Y1-1
	MVI 511,R0
	COMR R0
	ANDI #4,R0
	TSTR R0
	BEQ T23
	MVI V17,R0
	CMPI #0,R0
	BLE T24
	MVI V17,R0
	DECR R0
	MVO R0,V17
T24:
T23:
	; 	IF CONT1.DOWN THEN IF Y1<104 THEN Y1=Y1+1
	MVI 511,R0
	COMR R0
	ANDI #1,R0
	TSTR R0
	BEQ T26
	MVI V17,R0
	CMPI #104,R0
	BGE T27
	MVI V17,R0
	INCR R0
	MVO R0,V17
T27:
T26:
	; 	IF CONT1.LEFT THEN IF X1>0 THEN X1=X1-1
	MVI 511,R0
	COMR R0
	ANDI #8,R0
	TSTR R0
	BEQ T29
	MVI V16,R0
	CMPI #0,R0
	BLE T30
	MVI V16,R0
	DECR R0
	MVO R0,V16
T30:
T29:
	; 	IF CONT1.RIGHT THEN IF X1<168 THEN X1=X1+1
	MVI 511,R0
	COMR R0
	ANDI #2,R0
	TSTR R0
	BEQ T32
	MVI V16,R0
	CMPI #168,R0
	BGE T33
	MVI V16,R0
	INCR R0
	MVO R0,V16
T33:
T32:
	;         ' Check for change of room
	;         IF Y1<8 OR X1<24 OR X1>144 OR Y1>96 THEN #score=#score+1:GOTO load_room
	MVI V17,R0
	CMPI #8,R0
	MVII #1,R0
	BLT T36
	DECR R0
T36:
	MVI V16,R1
	CMPI #24,R1
	MVII #1,R1
	BLT T37
	DECR R1
T37:
	COMR R1
	ANDR R1,R0
	COMR R1
	XORR R1,R0
	MVI V16,R1
	CMPI #144,R1
	MVII #1,R1
	BGT T38
	DECR R1
T38:
	COMR R1
	ANDR R1,R0
	COMR R1
	XORR R1,R0
	MVI V17,R1
	CMPI #96,R1
	MVII #1,R1
	BGT T39
	DECR R1
T39:
	COMR R1
	ANDR R1,R0
	COMR R1
	XORR R1,R0
	TSTR R0
	BEQ T35
	MVI V2,R0
	INCR R0
	MVO R0,V2
	B Q3
T35:
	;         SOUND 0,2000,FRAME AND 15
	MVII #2000,R0
	MVO R0,$01f0
	SWAP R0
	MVO R0,$01f4
	MVI _frame,R0
	ANDI #15,R0
	MVO R0,$01fb
	;         IF BLINK THEN SOUND 1,500,15:BLINK=0 ELSE SOUND 1,,0
	MVI V18,R0
	TSTR R0
	BEQ T40
	MVII #500,R0
	MVO R0,$01f1
	SWAP R0
	MVO R0,$01f5
	MVII #15,R0
	MVO R0,$01fc
	CLRR R0
	MVO R0,V18
	B T41
T40:
	CLRR R0
	MVO R0,$01fc
T41:
	; 
	;         ' Barzacks displacement
	;         IF FRAME AND 7 THEN GOTO loop
	MVI _frame,R0
	ANDI #7,R0
	TSTR R0
	BEQ T42
	B Q7
T42:
	;         IF Y2=0 THEN GOTO avoid1
	MVI V7,R0
	CMPI #0,R0
	BNE T43
	B Q9
T43:
	;         IF X1<>X2 THEN IF X1<X2 THEN X2=X2-1 ELSE X2=X2+1
	MVI V16,R0
	CMP V8,R0
	BEQ T45
	MVI V16,R0
	CMP V8,R0
	BGE T47
	MVI V8,R0
	DECR R0
	MVO R0,V8
	B T49
T47:
	MVI V8,R0
	INCR R0
	MVO R0,V8
T49:
T45:
	;         IF Y1<>Y2 THEN IF Y1<Y2 THEN Y2=Y2-1 ELSE Y2=Y2+1
	MVI V17,R0
	CMP V7,R0
	BEQ T50
	MVI V17,R0
	CMP V7,R0
	BGE T52
	MVI V7,R0
	DECR R0
	MVO R0,V7
	B T54
T52:
	MVI V7,R0
	INCR R0
	MVO R0,V7
T54:
T50:
	; avoid1:
	; AVOID1
Q9:	;         IF Y3=0 THEN GOTO avoid2
	MVI V10,R0
	CMPI #0,R0
	BNE T55
	B Q11
T55:
	;         IF X1<>X3 THEN IF X1<X3 THEN X3=X3-1 ELSE X3=X3+1
	MVI V16,R0
	CMP V11,R0
	BEQ T57
	MVI V16,R0
	CMP V11,R0
	BGE T59
	MVI V11,R0
	DECR R0
	MVO R0,V11
	B T61
T59:
	MVI V11,R0
	INCR R0
	MVO R0,V11
T61:
T57:
	;         IF Y1<>Y3 THEN IF Y1<Y3 THEN Y3=Y3-1 ELSE Y3=Y3+1
	MVI V17,R0
	CMP V10,R0
	BEQ T62
	MVI V17,R0
	CMP V10,R0
	BGE T64
	MVI V10,R0
	DECR R0
	MVO R0,V10
	B T66
T64:
	MVI V10,R0
	INCR R0
	MVO R0,V10
T66:
T62:
	; avoid2:
	; AVOID2
Q11:	;         IF Y4=0 THEN GOTO avoid3
	MVI V12,R0
	CMPI #0,R0
	BNE T67
	B Q13
T67:
	;         IF X1<>X4 THEN IF X1<X4 THEN X4=X4-1 ELSE X4=X4+1
	MVI V16,R0
	CMP V13,R0
	BEQ T69
	MVI V16,R0
	CMP V13,R0
	BGE T71
	MVI V13,R0
	DECR R0
	MVO R0,V13
	B T73
T71:
	MVI V13,R0
	INCR R0
	MVO R0,V13
T73:
T69:
	;         IF Y1<>Y4 THEN IF Y1<Y4 THEN Y4=Y4-1 ELSE Y4=Y4+1
	MVI V17,R0
	CMP V12,R0
	BEQ T74
	MVI V17,R0
	CMP V12,R0
	BGE T76
	MVI V12,R0
	DECR R0
	MVO R0,V12
	B T78
T76:
	MVI V12,R0
	INCR R0
	MVO R0,V12
T78:
T74:
	; avoid3:
	; AVOID3
Q13:	;         IF Y5=0 THEN GOTO avoid4
	MVI V14,R0
	CMPI #0,R0
	BNE T79
	B Q15
T79:
	;         IF X1<>X5 THEN IF X1<X5 THEN X5=X5-1 ELSE X5=X5+1
	MVI V16,R0
	CMP V15,R0
	BEQ T81
	MVI V16,R0
	CMP V15,R0
	BGE T83
	MVI V15,R0
	DECR R0
	MVO R0,V15
	B T85
T83:
	MVI V15,R0
	INCR R0
	MVO R0,V15
T85:
T81:
	;         IF Y1<>Y5 THEN IF Y1<Y5 THEN Y5=Y5-1 ELSE Y5=Y5+1
	MVI V17,R0
	CMP V14,R0
	BEQ T86
	MVI V17,R0
	CMP V14,R0
	BGE T88
	MVI V14,R0
	DECR R0
	MVO R0,V14
	B T90
T88:
	MVI V14,R0
	INCR R0
	MVO R0,V14
T90:
T86:
	; avoid4:
	; AVOID4
Q15:	; 	GOTO loop
	B Q7
	; 
	; barzack:        PROCEDURE
	; BARZACK
Q6:	PROC
	BEGIN
	; 
	; retry:
	; RETRY
Q18:	;         WAIT
	CALL _wait
	;         X = RAND % 16
	MVI _rand,R0
	ANDI #15,R0
	MVO R0,V6
	;         IF PEEK($0200+Y*20+X+2) GOTO retry
	MVI V4,R0
	MVII #19,R4
	MOVR R0,R5
T92:
	ADDR R5,R0
	DECR R4
	BNE T92
	ADDI #512,R0
	ADD V6,R0
	ADDI #2,R0
	MOVR R0,R4
	MVI@ R4,R0
	TSTR R0
	BEQ T91
	B Q18
T91:
	;         result = (x + 2) * 8 + 8       
	MVI V6,R0
	ADDI #2,R0
	SLL R0,2
	SLL R0,1
	ADDI #8,R0
	MVO R0,V9
	; 
	;         END
	RETURN
	ENDP
	; 
	; touched:       
	; TOUCHED
Q8:	; 
	;         FOR color = 0 TO 31
	CLRR R0
	MVO R0,V19
T93:
	;         WAIT
	CALL _wait
	;         SPRITE 0,X1+$300,Y1+$100,$0810+(color AND 7) ' Our hero
	MVI V16,R0
	ADDI #768,R0
	MVO R0,_mobs+0
	MVI V17,R0
	ADDI #256,R0
	MVO R0,_mobs+8
	MVI V19,R0
	ANDI #7,R0
	ADDI #2064,R0
	MVO R0,_mobs+16
	;         SOUND 0,(color and 7)*32+32,15
	MVI V19,R0
	ANDI #7,R0
	MVII #31,R4
	MOVR R0,R5
T94:
	ADDR R5,R0
	DECR R4
	BNE T94
	ADDI #32,R0
	MVO R0,$01f0
	SWAP R0
	MVO R0,$01f4
	MVII #15,R0
	MVO R0,$01fb
	;         SOUND 1,(color and 7)*36+32,15
	MVI V19,R0
	ANDI #7,R0
	MVII #35,R4
	MOVR R0,R5
T95:
	ADDR R5,R0
	DECR R4
	BNE T95
	ADDI #32,R0
	MVO R0,$01f1
	SWAP R0
	MVO R0,$01f5
	MVII #15,R0
	MVO R0,$01fc
	;         SOUND 2,(color and 7)*40+32,15
	MVI V19,R0
	ANDI #7,R0
	MVII #39,R4
	MOVR R0,R5
T96:
	ADDR R5,R0
	DECR R4
	BNE T96
	ADDI #32,R0
	MVO R0,$01f2
	SWAP R0
	MVO R0,$01f6
	MVII #15,R0
	MVO R0,$01fd
	;         NEXT
	MVII #31,R0
	CMP V19,R0
	BLE T97
	MVI V19,R0
	INCR R0
	MVO R0,V19
	B T93
T97:
	;         SOUND 0,,0
	CLRR R0
	MVO R0,$01fb
	;         SOUND 1,,0
	CLRR R0
	MVO R0,$01fc
	;         SOUND 2,,0
	CLRR R0
	MVO R0,$01fd
	; 
	;         FOR loop = 0 to 100
	CLRR R0
	MVO R0,V20
T98:
	;         WAIT
	CALL _wait
	;         NEXT
	MVII #100,R0
	CMP V20,R0
	BLE T99
	MVI V20,R0
	INCR R0
	MVO R0,V20
	B T98
T99:
	; 
	;         ' Deactivate sprites
	;         SPRITE 0,0,0
	CLRR R0
	MVO R0,_mobs+0
	CLRR R0
	MVO R0,_mobs+8
	;         SPRITE 1,0,0
	CLRR R0
	MVO R0,_mobs+1
	CLRR R0
	MVO R0,_mobs+9
	;         SPRITE 2,0,0
	CLRR R0
	MVO R0,_mobs+2
	CLRR R0
	MVO R0,_mobs+10
	;         SPRITE 3,0,0
	CLRR R0
	MVO R0,_mobs+3
	CLRR R0
	MVO R0,_mobs+11
	;         SPRITE 4,0,0
	CLRR R0
	MVO R0,_mobs+4
	CLRR R0
	MVO R0,_mobs+12
	; 
	;         GOTO restart
	B Q2
	; 
	; room0:
	; ROOM0
Q4:	;         DATA $FFFF,$8001,$8001,$87E1,$8021,$8020
	DECLE 65535
	DECLE 32769
	DECLE 32769
	DECLE 34785
	DECLE 32801
	DECLE 32800
	;         DATA $8020,$8021,$87E1,$8001,$8001,$FFFF
	DECLE 32800
	DECLE 32801
	DECLE 34785
	DECLE 32769
	DECLE 32769
	DECLE 65535
	; room1:
	; ROOM1
Q5:	;         DATA $FFFF,$8001,$8001,$8421,$8421,$8421
	DECLE 65535
	DECLE 32769
	DECLE 32769
	DECLE 33825
	DECLE 33825
	DECLE 33825
	;         DATA $8421,$8421,$8421,$8001,$8001,$FC3F
	DECLE 33825
	DECLE 33825
	DECLE 33825
	DECLE 32769
	DECLE 32769
	DECLE 64575
	; 
	; drawings:
	; DRAWINGS
Q1:	; 	BITMAP "10011001"
	; 	BITMAP "11111111"
	DECLE 65433
	; 	BITMAP "01011010"
	; 	BITMAP "01111110"
	DECLE 32346
	; 	BITMAP "00111100"
	; 	BITMAP "00100100"
	DECLE 9276
	; 	BITMAP "00100100"
	; 	BITMAP "01100110"
	DECLE 26148
	; 
	; 	BITMAP "00011000"
	; 	BITMAP "00011000"
	DECLE 6168
	; 	BITMAP "00111100"
	; 	BITMAP "00100100"
	DECLE 9276
	; 	BITMAP "00111100"
	; 	BITMAP "00111100"
	DECLE 15420
	; 	BITMAP "01111110"
	; 	BITMAP "11111111"
	DECLE 65406
	; 
	; 	BITMAP "00011000"
	; 	BITMAP "00011000"
	DECLE 6168
	; 	BITMAP "01111110"
	; 	BITMAP "00011000"
	DECLE 6270
	; 	BITMAP "00011000"
	; 	BITMAP "00111100"
	DECLE 15384
	; 	BITMAP "00100100"
	; 	BITMAP "01100110"
	DECLE 26148
	; 
	; 	BITMAP "01100000"
	; 	BITMAP "11100000"
	DECLE 57440
	; 	BITMAP "01100000"
	; 	BITMAP "01111111"
	DECLE 32608
	; 	BITMAP "01111110"
	; 	BITMAP "01100110"
	DECLE 26238
	; 	BITMAP "01100110"
	; 	BITMAP "11101110"
	DECLE 61030
        ;
        ; Wait for interruption
        ;
_wait:  PROC
        CLRR    R0
        MVO     R0,_int         ; Clears waiting flag
@@1:    CMP     _int,  R0       ; Waits for change
        BEQ     @@1
        JR      R5              ; Returns
        ENDP

        ;
        ; Interruption routine
        ;
_int_vector:     PROC
        BEGIN

        MVO     R0,     $20     ; Activates display
        MVI     $21,    R0      ; Activates mode for 64 definitions of MOB
        MVII    #1,     R0
        MVO     R0,     _int    ; Indicates interrupt happened
        MVI _first_time,R0
        TSTR R0
        BEQ @@vi0
        DECR R0
        MVO R0,_first_time
        MVII    #0,     R0
        MVO     R0,     $28     ; Color stack 0
        MVO     R0,     $2A     ; Color stack 2
        MVO     R0,     $2C     ; Border color
@@vi0:
        ;
        ; Detect GRAM definition
        ;
        MVI _load_gram,R0
        TSTR R0
        BEQ @@vi1
        CLRR R0
        MVO R0,_load_gram
        MVI _gram_bitmap,R4
        MVI _gram_target,R1
        SLL R1,2
        SLL R1,1
        ADDI #$3800,R1
        MOVR R1,R5
        MVI _gram_total,R0
@@vi3:
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        DECR R0
        BNE @@vi3
@@vi1:
    MVI     $18,R0
    MVO     R0,_col0
    MVI     $19,R0
    MVO     R0,_col1
    MVI     $1A,R0
    MVO     R0,_col2
    MVI     $1B,R0
    MVO     R0,_col3
    MVI     $1C,R0
    MVO     R0,_col4
    MVI     $1D,R0
    MVO     R0,_col5
    MVI     $1E,R0
    MVO     R0,_col6
    MVI     $1F,R0
    MVO     R0,_col7
	MVII	#0,R0
	MVO 	R0,$18
	MVO 	R0,$19
    MVO     R0,$1A
    MVO     R0,$1B
    MVO     R0,$1C
    MVO     R0,$1D
	MVO 	R0,$1E
    MVO     R0,$1F
    
        ; Updates sprites (MOBs)
        MVII #_mobs,R4
        MVII #$0,R5     ; X-coordinates
        MVII #8,R1
@@vi2:  MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        DECR R1
        BNE @@vi2

        ; Random number generator
MACRO _ROR
	RRC R0,1
	MOVR R0,R1
	SLR R1,2
	SLR R1,2
	ANDI #$0800,R1
	SLR R1,2
	SLR R1,2
	ANDI #$007F,R0
	XORR R1,R0
ENDM
        MVI _rand,R0
        SETC
        _ROR
        XOR _frame,R0
        _ROR
        XOR _rand,R0
        _ROR
        XORI #9,R0
        MVO R0,_rand

        ; Increase frame number
        MVI _frame,R0
        INCR R0
        MVO R0,_frame

        RETURN
        ENDP
    
        ORG $330,$330,"-RWB"
_frame:     RMB 1
_read:      RMB 1  
_gram_bitmap:   RMB 1
_screen:    RMB 1
_color:     RMB 1
_mobs:      RMB 3*8
_col0:      RMB 1
_col1:      RMB 1
_col2:      RMB 1
_col3:      RMB 1
_col4:      RMB 1
_col5:      RMB 1
_col6:      RMB 1
_col7:      RMB 1

SCRATCH:    ORG $100,$100,"-RWBN"
ISRVEC:     RMB 2
_int:       RMB 1
_rand:      RMB 1
_load_gram: RMB 1
_gram_target:   RMB 1
_gram_total:    RMB 1
_first_time:    RMB 1
V18:	RMB 1	; BLINK
V19:	RMB 1	; COLOR
V20:	RMB 1	; LOOP
V9:	RMB 1	; RESULT
V1:	RMB 1	; ROOM
V6:	RMB 1	; X
V16:	RMB 1	; X1
V8:	RMB 1	; X2
V11:	RMB 1	; X3
V13:	RMB 1	; X4
V15:	RMB 1	; X5
V4:	RMB 1	; Y
V17:	RMB 1	; Y1
V7:	RMB 1	; Y2
V10:	RMB 1	; Y3
V12:	RMB 1	; Y4
V14:	RMB 1	; Y5
_SCRATCH:	EQU $

SYSTEM:	ORG $2F0, $2F0, "-RWBN"
STACK:	RMB 32
V5:	RMB 1	; #LINE
V3:	RMB 1	; #MONSTER
V2:	RMB 1	; #SCORE
_SYSTEM:	EQU $
